#ifndef __BIOSCALL_H
#define __BIOSCALL_H

#include "bios.h"

#define BIOSCALL_INIT				0x00000000
#define BIOSCALL_REBOOT				0x00000001
#define BIOSCALL_GET_VENDORID			0x00000002
#define BIOSCALL_GET_DEVICEID			0x00000003
#define BIOSCALL_GET_REV			0x00000004
#define BIOSCALL_GET_BIOSTABLEOFFSET		0x00000005
#define BIOSCALL_GET_SAFETABLEOFFSET		0x00000006
#define BIOSCALL_GET_BIOSOFFSET			0x00000007
#define BIOSCALL_GET_BIOSSIZE			0x00000008
#define BIOSCALL_GET_ROMBASE			0x00000009
#define BIOSCALL_GET_ROMSIZE			0x0000000a
#define BIOSCALL_GET_DRAMBASE			0x0000000b
#define BIOSCALL_GET_DRAMSIZE			0x0000000c
#define BIOSCALL_GET_STARTUPMODE		0x0000000d
#define BIOSCALL_GET_USERFLAG			0x0000000e
#define BIOSCALL_SET_USERFLAG			0x0000000f
#define BIOSCALL_FLASH_ERASE			0x00000010
#define BIOSCALL_FLASH_READ			0x00000011
#define BIOSCALL_FLASH_WRITE			0x00000012

int bios_call(unsigned long id, unsigned long arg);
int bios_reboot(void);
unsigned short bios_vendor_id(void);
unsigned short bios_device_id(void);
unsigned long bios_rev(void);
unsigned long bios_bios_table_offset(void);
unsigned long bios_safe_table_offset(void);
unsigned long bios_bios_offset(void);
unsigned long bios_bios_size(void);
unsigned long bios_rom_base(void);
unsigned long bios_rom_size(void);
unsigned long bios_dram_base(void);
unsigned long bios_dram_size(void);
unsigned long bios_startup_mode(void);
unsigned long bios_get_userflag(void);
unsigned long bios_set_userflag(unsigned long userflag);
int bios_flash_erase(unsigned long adr, unsigned long size);
int bios_flash_read(unsigned long from,
	unsigned long len, unsigned long *retlen, unsigned char *buf);
int bios_flash_write(unsigned long to,
	unsigned long len, unsigned long *retlen, unsigned char *buf);
int bios_bios_table(struct bios_table_struct *bios_table);
int bios_safe_table(struct bios_table_struct *safe_table);
int bios_eth_cfg(struct sys_eth_cfg *cfg);


#endif  /* __BIOSCALL_H */
