#ifndef _CONFIG_H
#define _CONFIG_H

#include "board.h"

/* System memory map */
#define ROM_BASE		0x01000000	/* do not use it, use _rom_base */
#define DRAM_BASE		0x00000000
#define EXTIO_BASE		ASIC_EXTIO_BASE
#define SRAM_BASE		ASIC_SRAM_BASE
#define REG_BASE		ASIC_REG_BASE

/* RAM memory map */
#define BIOS_API_ADDR		0x00001000
#define GUNZIP_ADDR		0x00004000
#define SETUP_ADDR		0x00180000
#define FDISK_ADDR		0x00180000
#define TFTP_ADDR		0x00380000
#define BUF_ADDR		0x00008000

/* ROM memory map */
#define BIOS_SIZE		0x00020000
#define BIOS_CORE_SIZE		0x0000c000	/* 48K */

#define BIOS_CORE_OFFSET	0x00000000
#define SAFE_TABLE_OFFSET	0x0000c000
#define BIOS_TABLE_OFFSET	0x00010000

/* SYSCFG settings */
#define rSYSCFG_BIOS ( \
	SYS_ALWAYS_SET | \
	SYS_CACHE_OFF | \
	SYS_WBUF_OFF | \
	SYS_CACHE_4K \
)

#define rSYSCFG_FLUSH ( \
	SYS_ALWAYS_SET | \
	SYS_CACHE_OFF | \
	SYS_WBUF_OFF | \
	SYS_CACHE_8K \
)


#endif
