#ifndef __CONSOLE_H
#define __CONSOLE_H

#define KEY_BACKSPACE  0x08
#define KEY_ENTER      0x0d
#define KEY_ESC        0x1b


int console_init(void);
int console_write(int ch);
int console_read(void);

int kbhit(void);
int getch(void);
int putch(int ch);
int puts(const char *s);
char *getpass(char *s, int n, char prompt);
char *gets(char *s, int n);
unsigned long getul(unsigned long def, int radix);
unsigned char getuc(unsigned char def, int radix);
int printf(const char *s, ...);
int get_select(int min, int max);
int get_select_enter(int min, int max);
int get_yes_no(int def);
int get_enter_esc(void);

#endif /* __CONSOLE_H */
